"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
class ConfigMgr {
    constructor() {
        this._configValue = {};
        this._defaultValue = {};
        this._filePath = '';
        this._filePath = path.join(process.cwd(), 'config.json');
        fs.watchFile(this._filePath, this._watchFile.bind(this));
        this._loadFile();
    }
    static get inst() {
        if (!this._inst)
            this._inst = new ConfigMgr();
        return this._inst;
    }
    static get(v, int = false) {
        if (int) {
            return parseInt(this.inst.get(v));
        }
        return this.inst.get(v);
    }
    static has(v) {
        return this.inst.has(v);
    }
    static default(d) {
        return this.inst.registDefault(d);
    }
    _loadFile() {
        try {
            var jt = fs.readFileSync(this._filePath);
            this._configValue = JSON.parse(jt.toString());
        }
        catch (e) {
        }
    }
    _watchFile(curr, prev) {
        if (prev.ctime.getTime() == 0 && curr.ctime.getTime() != 0) {
            //console.log('文件被创建!');
            this._loadFile();
        }
        else if (curr.ctime.getTime() == 0) {
            // console.log('文件被删除!');
            // 文件删除了，但是配置先不要响应删除操作了
        }
        else if (curr.mtime.getTime() != prev.mtime.getTime()) {
            // console.log('文件有修改');
            this._loadFile();
        }
    }
    registDefault(def) {
        this._defaultValue = Object.assign(this._defaultValue, def);
    }
    _get(srcObj, key) {
        var arr = key.split('.');
        var tObj = srcObj;
        for (var i = 0; i < arr.length; i++) {
            if (!tObj)
                return null;
            tObj = tObj[arr[i]];
        }
        return tObj;
    }
    get(key) {
        var ret = this._get(this._configValue, key);
        if (ret == null)
            ret = this._get(this._defaultValue, key);
        if (ret == null)
            ret = 0;
        return ret;
    }
    _has(srcObj, key) {
        var arr = key.split('.');
        var tObj = srcObj;
        for (var i = 0; i < arr.length; i++) {
            if (!tObj || !tObj.hasOwnProperty(arr[i]))
                return false;
            tObj = tObj[arr[i]];
        }
        return true;
    }
    has(key) {
        // this._use_key_log(key);
        // 先找动态的
        // 再找配置的
        // 最后找默认的
        var ret = false;
        if (ret == false)
            ret = this._has(this._configValue, key);
        if (ret == false)
            ret = this._has(this._defaultValue, key);
        if (ret == false)
            ret = false;
        return ret;
    }
    /**
     * 制作json配置用的模板文件，或者说把配置用的js文件转成json文件，主要是json是不能有注释的
     */
    createTemplateJson() {
        // 这里把defalut的生成一个json的就可以了
        var jsonFile = JSON.stringify(this._defaultValue, null, 4);
        fs.writeFileSync(path.join(process.cwd(), 'config.templete'), jsonFile);
    }
}
exports.ConfigMgr = ConfigMgr;
