/**
 * 开始二分法查找
 * @param list 查找用的列表
 * @param key 查找的单位元素
 * @param value 比较用的数值
 */
declare function orderListFind<T>(list: Array<T>, key: string, value: any, desc?: boolean): number;
declare function orderListInsert<T>(insertValue: T, list: Array<T>, key: string, value: any, desc?: boolean): void;
declare function orderListRemove<T>(list: Array<T>, key: string, value: any, desc?: boolean): void;
export declare class TeMap<T> {
    _data: any;
    constructor(_data?: Object);
    has(key: string | number): any;
    get(key: string | number): T;
    set(key: string | number, v: T): void;
    readonly keys: string[];
    del(key: string | number): void;
    rand(): T;
    clear(): void;
}
/**
 * list 的方式实现map
 */
export declare class MapList<T> {
    _data: Array<T>;
    mkey: string;
    constructor(mkey: string);
    private _find_index;
    has(k: number | string): boolean;
    at(idx: number): T;
    get(v: number | string): T | null;
    set(k: number | string, v: T): void;
    remove(v: number | string): void;
    readonly length: number;
    clear(): void;
}
declare function promise_setInterval(callback: () => Promise<any>, time: number): {
    stop: () => void;
};
declare function promise_setInterval(name: string, callback: () => Promise<any>, time: number): {
    stop: () => void;
};
export declare class TeRandom {
    private _seed;
    static DEFAULT_SEED: number;
    constructor(seed?: number);
    reset(seed: number): void;
    readonly seed: number;
    random(min?: number, max?: number, msg?: string): number;
    randInt(max?: number, min?: number, msg?: string): number;
}
export declare class HashMap<T> {
    _data: {
        [key: string]: T[];
    };
    constructor();
    get(key: string | number): T[];
    add(key: string | number, v: T): void;
    readonly keys: string[];
    set(key: string | number, v: Array<T>): void;
    clear(): void;
    has(key: string | number, v?: T): boolean;
    sort(fn: (a: T, b: T) => number): void;
}
declare function func_copy<T>(obj: T | any, bFunc?: boolean): T;
export declare var Util: {
    Sort: {
        orderListFind: typeof orderListFind;
        orderListRemove: typeof orderListRemove;
        orderListInsert: typeof orderListInsert;
    };
    Map: typeof TeMap;
    MapList: typeof MapList;
    setInterval: typeof promise_setInterval;
    switchShowInterval: (b: boolean) => void;
    Random: typeof TeRandom;
    HashMap: typeof HashMap;
    copy: typeof func_copy;
};
export {};
