interface ifRunningPromise<T> {
    (...args: T[]): Promise<any>;
}
/**
 * 提供执行不同处理过程的协程
 * 返回只有 resolve的方式，没有 reject的执行
 * @param pools 执行程序池子
 * @param threadNum 启动的执行协程数量
 * @param args 每个方法执行的时候使用相同的参数组
 */
export declare function execPools<T>(pools: ifRunningPromise<T>[], threadNum: number, ...args: any[]): Promise<unknown>;
/**
 * 执行相同处理过程的协程
 * 返回只有 resolve的方式，没有 reject的执行
 * @param exec 执行方法
 * @param threadNum 协程数量
 * @param args 执行的数据池子
 */
export declare function execPools2<T>(exec: ifRunningPromise<T>, threadNum: number, ...args: T[]): Promise<unknown>;
export {};
