/// <reference types="node" />
export declare class GroupMgr {
    static create(host: string, port: number, roleId: string, groupId: string, score: number, info: any): GroupMgr;
    private host;
    private port;
    private selfInfo;
    private groupId;
    private groupInfo;
    private event;
    private socket;
    constructor(host: string, port: number);
    init(): Promise<unknown>;
    private onConnection;
    readonly isMaster: boolean;
    getRole(roleId: string): number;
    readonly masterRoleId: string;
    readonly roleId: string;
    private hellback;
    private onsayhellotiemout;
    sayhello(data: string | Buffer): Promise<unknown>;
    private onData;
    private onClose;
    close(): void;
    joinGroup(roleId: string, groupId: string, score: number, info: any): boolean;
    private _pushData;
    pushMsg(targetId: string, info: {
        [key: string]: any;
    }): boolean;
    pushBroadcast(info: {
        [key: string]: any;
    }): boolean;
    private onInit;
    private parseRole;
    private onJoin;
    private onLeave;
    private onRoleResult;
    private onTalk;
    on(event: 'connection', listener: (...args: any[]) => void): this;
    on(event: 'open', listener: (...args: any[]) => void): this;
    on(event: 'data', listener: (srcId: string, info: {
        [key: string]: any;
    }) => void): this;
    on(event: 'close', listener: (...args: any[]) => void): this;
    on(event: 'error', listener: (...args: any[]) => void): this;
    on(event: string | symbol, listener: (...args: any[]) => void): this;
    once(event: 'connection', listener: (...args: any[]) => void): this;
    once(event: 'open', listener: (...args: any[]) => void): this;
    once(event: 'data', listener: (srcId: string, info: {
        [key: string]: any;
    }) => void): this;
    once(event: 'close', listener: (...args: any[]) => void): this;
    once(event: 'error', listener: (...args: any[]) => void): this;
    once(event: string | symbol, listener: (...args: any[]) => void): this;
    off(event: string | symbol, listener: (...args: any[]) => void): this;
}
