/// <reference types="node" />
import { TcpServer } from "../TcpNet";
import { eMasterC2SType, eMasterS2CType } from "./proto";
import { EventEmitter } from "events";
export declare class Master extends EventEmitter {
    server: TcpServer;
    constructor();
    init(port: number): Promise<boolean>;
    private onConnection;
    on(event: 'open', listener: (sockaddr: string) => void): this;
    on(event: 'data', listener: (cmd: eMasterC2SType, sockaddr: string, data: {
        [x: string]: any;
    }) => void): this;
    on(event: 'close', listener: (sockaddr: string) => void): this;
    once(event: 'open', listener: (sockaddr: string) => void): this;
    once(event: 'data', listener: (cmd: eMasterC2SType, sockaddr: string, data: {
        [x: string]: any;
    }) => void): this;
    once(event: 'close', listener: (sockaddr: string) => void): this;
    pushData(sockaddr: string, cmd: eMasterS2CType, data: string | Buffer): boolean;
    private hellback;
    private sayhelloTimeout;
    sayhello(sockaddr: string, data: {
        [x: string]: any;
    }): Promise<unknown>;
    private onData;
    private onClose;
}
export declare var MasterNet: Master;
