/// <reference types="node" />
import NodeRSA from 'node-rsa';
export declare type EncryptionSchemeType = NodeRSA.EncryptionScheme | NodeRSA.AdvancedEncryptionScheme;
export declare class RsaAesClient {
    private AZaz09;
    private option;
    private algorithmOption;
    constructor(size?: number, encryptionScheme?: EncryptionSchemeType);
    loadAesKey(key: string, algorithm?: string): void;
    loadAes(aes: any): void;
    private _parseAlgorithm;
    private randWord;
    private useKeys;
    /**
     * 生成rsa 证书信息 返回公钥内容
     */
    private generateRsa;
    /**
     * 装在rsa公钥信息 返回NodeRsa对象
     * @param key
     */
    private loadPublicRsa;
    stepOne(pbkey: Buffer | string): Buffer;
    stepTwo(data: Buffer): boolean;
    encode(data: string): {
        encryptedData: string;
        iv: string | null;
    };
    decode(encryptedData: string, iv?: string | null): string;
}
