/// <reference types="node" />
/**
 * 对称加密数据
 * @param key 默认是 aes-128-cbc 模式 autoPadding=true 采用 Pad采用Pkcs7 模式
 * @param data 需要加密的数据 utf-8格式
 */
export declare function AesEncode(key: {
    algorithm: string;
    key: string;
    autoPadding: boolean;
} | string, data: string | Buffer): {
    encryptedData: string;
    iv: string | null;
};
/**
 * 对称解密数据
 * @param key 默认是 aes-128-cbc 模式 autoPadding=true 采用 Pad采用Pkcs7 模式
 * @param encryptedData base64的密钥
 * @param iv
 * @param binary 是否导出binary格式 否则导出 utf8
 */
export declare function AesDecode(key: {
    algorithm: string;
    key: string;
    autoPadding: boolean;
} | string, encryptedData: string, iv?: string | null, binary?: boolean): string;
