"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const fs_1 = require("fs");
let __routePools = {};
function regist(dirname, router, paramlist, func) {
    if (!__routePools[dirname])
        __routePools[dirname] = {};
    __routePools[dirname][router] = {
        list: paramlist,
        func: func
    };
}
exports.regist = regist;
// regist(__dirname,'upload', ['file', 'info', 'type'], async function () {
//     return { code: 0 }
// })
function deepRoouter(modulePath, pathlist, req, res, next) {
    let key = pathlist[0];
    if (!key)
        return next();
    let md;
    try {
        md = require(modulePath);
    }
    catch (e) {
        if (pathlist.length > 0) {
            pathlist.shift();
            return deepRoouter(path_1.join(modulePath, key), pathlist, req, res, next);
        }
        else {
            next();
        }
    }
    try {
        if (md[key] && typeof md[key] == 'function') {
            return md[key](req, res, next);
        }
        if (__routePools && typeof __routePools[modulePath] == 'object') {
            let unit = __routePools[modulePath][key];
            if (unit && unit.list && unit.list instanceof Array && typeof unit.func == 'function') {
                for (let i = 0; i < unit.list.length; i++) {
                    if (!req.params.hasOwnProperty(unit.list[i])) {
                        res.write(JSON.stringify({ code: 1, errMsg: "need param " + unit.list[i] }));
                        res.end();
                        return;
                    }
                }
                unit.func(req.params, req.headers).then(function (v) {
                    if (typeof v == 'string') {
                        res.write(v);
                    }
                    else {
                        res.write(JSON.stringify(v));
                    }
                    res.end();
                }).catch(e => {
                    if (e instanceof Error) {
                        res.write({ code: 5, errMsg: e.stack || e.message });
                        res.end();
                    }
                    else if (e && e.code) {
                        res.write(JSON.stringify(e));
                        res.end();
                    }
                    else if (typeof e == 'string') {
                        res.write(e);
                        res.end();
                    }
                    else {
                        next();
                    }
                });
                return;
            }
        }
        if (md.router && typeof md.router == 'function') {
            return md.router(pathlist, req, res, next);
        }
        let useDir = '';
        // 找找看有没有二级或者多级的目录
        let pf = path_1.parse(modulePath);
        if (fs_1.statSync(modulePath).isDirectory()) {
            // 调用xx机制
            useDir = modulePath;
        }
        else {
            useDir = pf.dir;
        }
        // 然后找模块继续route查询
        pathlist.shift();
        return deepRoouter(path_1.join(useDir, key), pathlist, req, res, next);
    }
    catch (e) {
        next();
    }
}
exports.deepRoouter = deepRoouter;
